package Basic3SV;

import java.util.*;

public class KeyMatch extends Object {

    public KeyMatch() {

    }

    // sort a table:
    // calculate the match between a string and a table which has a 
    // string in the 'posn' position (y-axis) 

public static void calculateMatch(String s, Table table, int posn) {
	Vector stringVector = new Vector();

	// calculate a trigram hashtable for s
	Hashtable shtable = Tri.genTrigramTable(s);
	
	// calculate a trigram hashtable for all Rows
	// keep this around for future reference ??
	for(int i=0;i<table.size();++i) {
	    Row r = table.getValue(i);
	    r.htable = Tri.genTrigramTable((r.getValue(posn)).value);
	}

	// calculate the match between shtable and  row.htable
	for(int i=0;i<table.size();++i) {
	    Row r = table.getValue(i);
	    r.score = Tri.compareTrigramTables(r.htable,shtable);
	}

	//sort the table using the scores
	callQuicksort(table);
    }


  /**
quicksort - adapted from Sedgewick's C version pp118
   */

  public static void callQuicksort(Table a) {
    if(a.size()>1)
    quicksort(a,0,a.size()-1);
  }

  public static void quicksort (Table a, int l, int r) {
      // Vector.elementAt ===> Table.getValue
      // Vector.setElementAt obj x  ===> Table.setValue x obj
    int i, j, k;
    Row v,t;
    k=a.size();
    if(r>l) {
      v = a.getValue(r);
      i=l-1;
      j=r;    
      //      System.out.println("qs: "+l+" "+r);
      for(;;) {
	for(;lessThan(a.getValue(++i),v) && i<k-1;) ;
	for(;greaterThan(a.getValue(--j),v) && j>0;); 
	if(i>=j) break;
	t = a.getValue(i);
	a.setValue(i,a.getValue(j));
	a.setValue(j,t);
	//	System.out.println("qs swap i j: "+i+" "+j);
        }
      t = a.getValue(i);
      a.setValue(i,a.getValue(r));
      a.setValue(r,t);
      //      System.out.println("qs swap i r: "+i+" "+r);
      quicksort(a,l,i-1);
      quicksort(a,i+1,r);
    }
  }

  public static boolean lessThan(Row a, Row b) {
    return a.score > b.score;
  }

  public static boolean greaterThan(Row a, Row b) {
    return a.score < b.score;
  }

    public static void main(String[] argv){

	Table t = new Table();
	Row r0 = new Row();
	Element e0 = new Element("name","p1","artificial intel");
	r0.addElement(e0);
	t.addRow(r0);

	Row r1 = new Row();
	Element e1 = new Element("name","q","artificial intelligence");
	r1.addElement(e1);
	t.addRow(r1);

	Row r2 = new Row();
	Element e2 = new Element("name","o","totally artificial");
	r2.addElement(e2);
	t.addRow(r2);

	Row r3 = new Row();
	Element e3 = new Element("name","p2","artificial intel");
	r3.addElement(e3);
	t.addRow(r3);

	System.out.println(t.toString());
	// each row has the string element to be compared in posn 0
	calculateMatch("artificial intelligence and music",t,0);
	System.out.println(t.toString());
    }
}
