package Basic3SV;

import java.io.*;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import java.net.*;


public class RDQLConnection {

    static private Writer  out;
    Table table;

    // get the result (XML String) from a query (String) representing a 
    // RDQL query in the required http format

    public static String postQuery(String s) {
	try {
	    s = URLEncoder.encode(s);
	    String result="";
	    URL yahoo = 
		new URL("http://triplestore.aktors.org/~swh/RDQLBeta/?q="+s);

	    BufferedReader in = new BufferedReader(
				   new InputStreamReader(yahoo.openStream()));
								
	    String inputLine;
	    while ((inputLine = in.readLine()) != null)
		result=result+inputLine;
	    in.close();
	    return result;
	} 
	catch(Exception e) {System.out.println("error"+e.toString());}
	return "";
    }

    // parse the XML at the URL directly, and create Objects
    public static void postQuery_ParseXML(String s) {
	s = URLEncoder.encode(s);
	SXML parser = new SXML();
	parser.callParserURI("http://triplestore.aktors.org/~swh/RDQLBeta/?q="+s);
	//	table = parser.table;
	//	System.out.println(">>>>"+table.getX());
    }


    public static void main(String[] argv) throws Exception {
	Table t = new Table();
	String response="";
	if (argv.length != 2) {
            System.err.println("Usage: cmd string|xml RDQL_query");
            System.exit(1);
        } 

	// get the URL content as a String	    
	if("xml".equals(argv[0])) {
	    postQuery_ParseXML(argv[1]); 
	    //	    System.out.println(t.toString());
	}
	else {
	    response = postQuery(argv[1]);
	    System.out.println(response);
	}
    }

}


    /*

java RDQLConnection xml 'SELECT ?name, ?uri, ?ri  WHERE (?uri, <http://www.aktors.org/ontology/portal#has-research-interest>, ?ri),(?ri,<http://www.w3.org/1999/02/22-rdf-syntax-ns#type>,<http://www.acm.org/class/1998/Research-Area>),(?ri,<http://www.aktors.org/ontology/portal#sub-area-of>,<http://www.acm.org/class/1998/D>),(?uri, <http://www.aktors.org/ontology/portal#has-pretty-name>, ?name)'


java RDQLConnection string 'SELECT ?name, ?uri, ?ri  WHERE (?uri, <http://www.aktors.org/ontology/portal#has-research-interest>, ?ri),(?ri,<http://www.w3.org/1999/02/22-rdf-syntax-ns#type>,<http://www.acm.org/class/1998/Research-Area>),(?uri, <http://www.aktors.org/ontology/portal#has-pretty-name>, ?name)'


    */
