package Basic3SV;

// tutorial XML example

import java.net.*;
import java.io.*;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.swing.*;
import java.awt.*;
import java.util.Vector;

public class SXML extends DefaultHandler
{
    StringBuffer textBuffer;
    boolean DEBUG0 = false;
    boolean DEBUG = false;
    Element currentElement=null;
    Row currentRow=null;
    public static Table table = new Table();
    public static Vector vector = new Vector();
    static int currentI = -1;
    static int currentJ = -1;
    public static Vector titles = new Vector();
    public static boolean NoMatches;

    public static void main(String argv[])
    {
        if (argv.length != 1) {
            System.err.println("Usage: cmd filename");
            System.exit(1);
        }
        callParser(argv[0]);
    }

    public static void clearTable() {
	table.clear();
	currentI = -1;
	currentJ = -1;
	titles.removeAllElements();
    }

    public class TTitle {
	public String title;
	public String type;

	public TTitle(String ti, String ty){
	    title = ti;
	    type = ty;
	}
	
	public String getTitle(){
	    return title;
	}

	public String getType(){
	    return type;
	}
    }

   public static void callParser(String filename) {
       clearTable();
        // Use an instance of ourselves as the SAX event handler
        DefaultHandler handler = new SXML();
 
        // Use the default (non-validating) parser
        SAXParserFactory factory = SAXParserFactory.newInstance();
        try {
            // Set up output stream
            out = new OutputStreamWriter(System.out, "UTF8");
 
            // Parse the input
            SAXParser saxParser = factory.newSAXParser();
            saxParser.parse( new File(filename), handler);

    	    Vector ltitles = new Vector();
	    for(int vi=0;vi<titles.size();vi++){
		ltitles.add(((TTitle) titles.elementAt(vi)).getTitle()+" ("+((TTitle) titles.elementAt(vi)).getType()+")");
	    }
//    	    titles.add("1");
//    	    titles.add("2");
//    	    titles.add("3");
	    
	    JTable jtable = new JTable(table.getVectorContent(), ltitles);
  	    JScrollPane scrollPane = new JScrollPane(jtable);
  	    jtable.setPreferredScrollableViewportSize(new Dimension(500, 70));
  	    JFrame frame = new JFrame("Query Results");
  	    frame.getContentPane().add(scrollPane, BorderLayout.CENTER);
  	    frame.pack();
  	    frame.setVisible(true); 

        } catch (Throwable t) {
            t.printStackTrace();
        }
        //System.exit(0);
    }

    public void callParserURI(String in) {
	clearTable();
	InputSource ins = new InputSource(in);

        // Use an instance of ourselves as the SAX event handler
        DefaultHandler handler = new SXML();

        // Use the default (non-validating) parser
        SAXParserFactory factory = SAXParserFactory.newInstance();
        try {
            // Set up output stream
            out = new OutputStreamWriter(System.out, "UTF8");

            // Parse the input
            SAXParser saxParser = factory.newSAXParser();
            saxParser.parse(ins, handler);

	    NoMatches = true;
	    if(table.size()>0){
		NoMatches = false;
		Vector ltitles = new Vector();
		for(int vi=0;vi<titles.size();vi++){
		    ltitles.add(((TTitle) titles.elementAt(vi)).getTitle()+" ("+((TTitle) titles.elementAt(vi)).getType()+")");
		}
		//System.out.println((table.getVectorContent()).toString());
//  		//System.out.println(titles.toString());

		// uncomment these lines to pop-up a table with the results:
//  		JTable jtable = new JTable(table.getVectorContent(), ltitles);
//  		JScrollPane scrollPane = new JScrollPane(jtable);
//  		jtable.setPreferredScrollableViewportSize(new Dimension(500, 70));
//  		JFrame frame = new JFrame("Query Results");
//  		frame.getContentPane().add(scrollPane, BorderLayout.CENTER);
//  		frame.pack();
//  		frame.setVisible(true); 
	    }

        } catch (Throwable t) {
            t.printStackTrace();
        }

    }

    public void callParserURI(String in, String svar, String sterm) {
	clearTable();
	InputSource ins = new InputSource(in);

        // Use an instance of ourselves as the SAX event handler
        DefaultHandler handler = new SXML();

        // Use the default (non-validating) parser
        SAXParserFactory factory = SAXParserFactory.newInstance();
        try {
            // Set up output stream
            out = new OutputStreamWriter(System.out, "UTF8");

            // Parse the input
            SAXParser saxParser = factory.newSAXParser();
            saxParser.parse(ins, handler);


	    NoMatches = true;
	    if(table.size()>0){

		boolean foundvar = false;
		int varct = 0;
		// if var name begins with a ? remove it:
		if(svar.startsWith("?")) svar = svar.substring(1);
		while(!foundvar && (varct<titles.size())){	
		    if((((TTitle) titles.elementAt(varct)).getTitle()).equalsIgnoreCase(svar)){
			foundvar = true;
			//System.out.println("found var: column "+varct);
		    }
		    else ++varct;
		}

		if(foundvar && !sterm.equalsIgnoreCase("")) KeyMatch.calculateMatch(sterm,table,varct);

		NoMatches = false;
		Vector ltitles = new Vector();
		for(int vi=0;vi<titles.size();vi++){
		    ltitles.add(((TTitle) titles.elementAt(vi)).getTitle()+" ("+((TTitle) titles.elementAt(vi)).getType()+")");
		}
		//System.out.println(table.toString());

		//System.out.println((table.getVectorContent()).toString());
		//System.out.println(titles.toString());

		JTable jtable;
		if(foundvar && !sterm.equalsIgnoreCase("")){
		    ltitles.add("score");
		    jtable = new JTable(table.getVectorContentAndScore(), ltitles);
		}
		else jtable = new JTable(table.getVectorContent(), ltitles);
		JScrollPane scrollPane = new JScrollPane(jtable);
		jtable.setPreferredScrollableViewportSize(new Dimension(500, 70));
		JFrame frame = new JFrame("Query Results");
		frame.getContentPane().add(scrollPane, BorderLayout.CENTER);
		frame.pack();
		frame.setVisible(true); 
	    }

        } catch (Throwable t) {
            t.printStackTrace();
        }

    }


    static private Writer  out;

    //===========================================================
    // SAX DocumentHandler methods
    //===========================================================

    public void startDocument()
    throws SAXException
    {
        if(DEBUG0) emit("<?xml version='1.0' encoding='UTF-8'?>");
        if(DEBUG0) nl();
    }

    public void endDocument()
    throws SAXException
    {
        try {
            nl();
            out.flush();
        } catch (IOException e) {
            throw new SAXException("I/O error", e);
        }
    }

    public void startElement(String namespaceURI,
                             String sName, // simple name
                             String qName, // qualified name
                             Attributes attrs)
    throws SAXException
    {
        echoText();
        String eName = sName; // element name
        if ("".equals(eName)) eName = qName; // not namespaceAware
        if(DEBUG0) emit("<(eName)"+eName);
	if(eName.equals("column")) {
	    currentJ++;
	}
	if(eName.equals("row")) { 
	    currentI++;
	    currentRow = new Row();
	}
        if (attrs != null && eName.equals("column")) {
	    if(attrs.getLength()==2) {
                String aName = attrs.getLocalName(0); // Attr name 
                if ("".equals(aName)) aName = attrs.getQName(0);
                String tName = attrs.getLocalName(1); // Attr name 
                if ("".equals(tName)) tName = attrs.getQName(1);

		if(currentI==0){
		    //System.out.println("inserting at: "+currentI+","+currentJ);
		    //titles.insertElementAt(attrs.getValue(0)+" ("+attrs.getValue(1)+")", currentJ);
		    titles.insertElementAt(new TTitle(attrs.getValue(0),attrs.getValue(1)), currentJ);

		}
		currentElement = new Element(attrs.getValue(0),attrs.getValue(1));

		if(DEBUG0) emit("(aName)"+aName+" = "+attrs.getValue(0)+"; "); 
		if(DEBUG0) emit("(aName)"+tName+" = "+attrs.getValue(1)+"; "); 
	    }
	    else emit("column does not have 2 attributes");
	}
    if(DEBUG0) emit(">");
    }

    public void endElement(String namespaceURI,
                           String sName, // simple name
                           String qName  // qualified name
                          )
    throws SAXException
    {
        echoText();
        String eName = sName; // element name
        if ("".equals(eName)) eName = qName; // not namespaceAware
        if(DEBUG0) emit("</"+eName+">");
	if(eName.equals("row")) { 
	    emit("\n"); 
	    currentJ=-1;
	    emit(currentRow.toString());
	    SXML.table.addRow(currentRow);
	    emit("<"+table.getX()+"  "+currentRow.getY()+">");
	}
    }

    public void characters(char buf[], int offset, int len)
    throws SAXException
    {
        String s = new String(buf, offset, len);
        if (textBuffer == null) {
           textBuffer = new StringBuffer(s);
        } else {
           textBuffer.append(s);
        }
    }
    
    //===========================================================
    // Utility Methods ...
    //===========================================================
    
    // Display text accumulated in the character buffer
    private void echoText()
    throws SAXException
    {
        if (textBuffer == null) return;
        String s = ""+textBuffer;
	if(!s.equals("\n")) {
	if(currentElement!=null)
	    currentElement.setValue(s);
        if(DEBUG0) emit("(txt)"+s);
	if(currentElement!=null) {
	    if(DEBUG) emit("["+currentI+" "+currentJ+"]"+currentElement.toString()+"\n");
	    currentRow.addElement(currentElement);
	}
	}
        textBuffer = null;
    }

    // Wrap I/O exceptions in SAX exceptions, to
    // suit handler signature requirements
    private void emit(String s)
    throws SAXException
    {
        try {
            out.write(s);
            out.flush();
        } catch (IOException e) {
            throw new SAXException("I/O error", e);
        }
    }

    // Start a new line
    private void nl()
    throws SAXException
    {
        String lineEnd =  System.getProperty("line.separator");
        try {
            out.write(lineEnd);
        } catch (IOException e) {
            throw new SAXException("I/O error", e);
        }
    }
}
