package Basic3SV;

import java.util.Vector;

public class Table extends Object {
	public Vector content;

    public Table(int x, int y) {
	content = new Vector(x);
	for(int i=0;i<content.size();++i)
	    content.addElement(new Row(y));
    }

    public Table(int x) {
	content = new Vector(x);
	for(int i=0;i<content.size();++i)
	    content.addElement(new Row());
    }

    public Table() {
	content = new Vector();
    }

    public void addRow(Row e) {
	content.addElement(e);
    }

    public void setValue(int x,Row e) {
	if(x<content.size())
	    content.setElementAt(e,x);
    }

    public Row getValue(int x) {
	if(x<content.size())
	    return (Row)content.elementAt(x);
	return null;
    }

    public Element getValue(int x, int y) {
	if(x<content.size()) {
	    Row r = (Row)content.elementAt(x);
	    return r.getValue(y);
	}
	return null;
    }
    
    public void setValue(Element z, int x, int y) {
	if(x<content.size()) {
	    Row r = (Row)content.elementAt(x);
	r.setValue(z,y);
	}
    }

    public void clear() {
	content.removeAllElements();
    }

    public int getX() {
	return content.size()-1;
    }

    public int size() {
	return content.size();
    }

    public String toString() {
	String s = "";
	for(int i=0;i<content.size();++i) 
	    s=s+i+":"+((Row)content.elementAt(i)).toString()+"\n";
	return s;
    }

    public Vector getVectorContent(){
	// should return a vector of vectors...
	Vector nv = new Vector();
	for(int i=0;i<content.size();i++){
	    nv.add(((Row) content.get(i)).getContent());
	}
	return nv;
    }

    public Vector getVectorContentAndScore(){
	// should return a vector of vectors...
	Vector nv = new Vector();
	for(int i=0;i<content.size();i++){
	    nv.add(((Row) content.get(i)).getContentAndScore());
	}
	return nv;
    }

    public Vector getFirstColumn(){
	Vector nv = new Vector();
	for(int i=0;i<content.size();i++){
	    nv.add(((Element) ((Row)(content.elementAt(i))).getValue(0)).getValue());
	    //System.out.println("added: "+((Element) ((Row)(content.elementAt(i))).getValue(0)).getValue());
	}
	return nv;
    }

    public Vector conflateFirstTwoColumns(){
	Vector nv = new Vector();
	for(int i=0;i<content.size();i++){
	    Row thisrow = (Row)(content.elementAt(i));
	    String firstval = (String) (thisrow.getValue(0)).getValue();
	    String secondval = (String) (thisrow.getValue(1)).getValue();
	    if(secondval==null || secondval.equalsIgnoreCase("") || secondval.equalsIgnoreCase(" ")) secondval = "n/a";
	    nv.add(firstval + " ("+ secondval +")");
	    //	    nv.add((thisrow.getValue(0)).getValue() + "(" + (thisrow.getValue(1)).getValue() + ")");
	    
	}
	return nv;
    }


    public Vector getFirstColumnYear(int year){
	// used when the second column in the table represents a year, and we want
	// to omit items of the first column that have a year < parameter year... 
	Vector nv = new Vector();
	for(int i=0;i<content.size();i++){
	    Row thisrow = (Row)(content.elementAt(i));
	    String firstval = ((String) (thisrow.getValue(0)).getValue()).toLowerCase();
	    int secondval = (new Integer((String) (thisrow.getValue(1)).getValue())).intValue();
	    //int secondval = (int) (thisrow.getValue(1)).getValue();
	    //if(secondval==null) secondval = 0;
	    //System.out.println("year="+secondval);
	    if(secondval>=year)
		nv.add(firstval);
	    //	    nv.add((thisrow.getValue(0)).getValue() + "(" + (thisrow.getValue(1)).getValue() + ")");
	    //else
	    //System.out.println("omitting:" +firstval);
	}
	return nv;
    }


    public String getFirstColumnString(){
	return((this.getFirstColumn()).toString());
    }
    public String getFirstTwoColumnsString(){
	Vector results = this.conflateFirstTwoColumns();
	//return((this.conflateFirstTwoColumns()).toString());
	String res = "";
	for(int i=0;i<results.size();i++){
	    res += (String) results.elementAt(i);
	    if(i<(results.size()-1)) res +=", ";
	}
	return res;
    }
    public String getFirstColumnStringYear(int year){
	Vector results = this.getFirstColumnYear(year);
	//return((this.conflateFirstTwoColumns()).toString());
	String res = "";
	for(int i=0;i<results.size();i++){
	    res += (String) results.elementAt(i);
	    if(i<(results.size()-1)) res +=", ";
	}
	return res;
    }
}

