@echo off
:: Script to start up an I-X Application
:: Austin Tate, AIAI, University of Edinburgh 23-May-2003

if "%1"=="/?" goto HELP

:: expects set variables app_path, ix_base, java_params, app_params and ipc

if "%ix_base%"=="" goto WRONG_LOCATION_IX

if not exist %ix_base%\scripts\win\run-ix-app.bat goto WRONG_LOCATION_IX

if not "%OS%"=="Windows_NT" goto RUN_APP
   :: commands that only work in Windows NT to improve appearance and behaviour
   pushd .
   setlocal
:RUN_APP

set ix_path=%ix_base%\ix.jar

:: >>>> use next 2 lines to override ix.jar with contents of java directory
:: set ix_path=%ix_base%\java;%ix_base%\ix.jar;
:: echo NOTE: overriding ix.jar with contents of ix_base\java directory

set ix_path=%ix_path%;%ix_base%\imports\xerces.jar
set ix_path=%ix_path%;%ix_base%\imports\jdom.jar
set ix_path=%ix_path%;%ix_base%\imports\mgraph.jar
set ix_path=%ix_path%;%ix_base%\imports\openmap.jar
:: note saxon.jar which may be present in the imports directory
:: for XSLT purposes is not required to run a normal I-X application

if "%ipc%"=="" (
   set comms_base=
   set comms_path=
   goto END-SETVARS
)
if "%ipc%"=="simple" (
   set comms_base=
   set comms_path=
   goto END-SETVARS
)
if "%ipc%"=="xml" (
   set comms_base=
   set comms_path=
   goto END-SETVARS
)

set comms_base=%ix_base%\comms\%ipc%
call %comms_base%\scripts\win\comms-setvars.bat %ix_base%

:END-SETVARS

set all_path=%ix_path%
if not "%comms_path%"=="" set all_path=%all_path%;%comms_path%
:: above adds java_paramas for any required java parameters
set java_params=-Dix.base=%ix_base% %java_params%

if not "%app_path%"=="" set all_path=%app_path%;%all_path%

:: could allow froman outer setting of the Java executable path as follows
:: set java_prefix=
:: if not "%JAVA_PATH%"=="" set java_prefix=%JAVA_PATH%\bin\
:: %java_prefix%java -classpath %all_path% %java_params% %1 %app_params%

:: set default java command, but override if java-command.bat script exists
set java_command=java
if exist %ix_base%\scripts\win\java-command.bat call %ix_base%\scripts\win\java-command.bat

%java_command% -version

echo java call parameters are:
echo ----- classpath=%all_path%
echo ----- java_params=%java_params%
echo ----- %1
echo ----- app_params=%app_params%

%java_command% -classpath %all_path% %java_params% %1 %app_params%

if not "%OS%"=="Windows_NT" goto END
:: commands that only work in Windows NT to improve appearance and behaviour
endlocal
popd
goto END

:WRONG_LOCATION_IX
   echo run-ix-app.bat: ix_base not correctly set
   pause
   goto END

:HELP
   echo run-ix-app.bat app-class
   echo     app-class  - application class name (e.g. ix.ip2.Ip2)
   pause
   goto END

:END




